﻿using LibreriaMulticast;
using System;
using System.Net;

/*
 *         Progetto: Progetto "Trasmissioni multicast"
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 13/06/2016
 *  
 *      Descrizione: Invia messaggi multicast utilizzando le funzioni
 *                   di "LibreriaMulticast".
 *                   
 */

namespace InviaMulticast
{
    class TX
    {
        static void Main(string[] args)
        {
            String[] indirizzi = new String[] {
                "224.4.4.4",
                "224.5.5.5"
            };
            const int porta = 2016;
            string info = "";
            int scelta;
            IPAddress ipLocale = UtilityMulticast.RicercaIpHostLAN();

            do
            {
                Console.Clear();
                if (!String.IsNullOrEmpty(info))
                {
                    Console.ForegroundColor = ConsoleColor.Yellow; 
                    Console.WriteLine(info);
                    Console.ResetColor();
                    info = "";
                }
                else
                    Console.WriteLine();

                Console.WriteLine();
                Console.WriteLine();
                Console.WriteLine("Selezionare l'indirizzo multicast a cui inviare un messaggio di test.");
                Console.WriteLine("Il messaggio sarà inviato sull'interfaccia di indirizzo {0}", ipLocale);
                Console.WriteLine();
                for (int i = 0; i < indirizzi.Length; i++)
                    Console.WriteLine("{0,4}. Invia un messaggio a {1}", i + 1, indirizzi[i]);

                Console.WriteLine("   0. Uscita");
                Console.WriteLine();
                Console.Write("Scelta: ");
                if (!Int32.TryParse(Console.ReadLine(), out scelta))
                    scelta = -1;
                if (scelta >= 1 && scelta <= indirizzi.Length)
                {
                    IPEndPoint mcast = new IPEndPoint(IPAddress.Parse(indirizzi[scelta - 1]), porta);
                    try
                    {
                        info = UtilityMulticast.InviaMessaggio(mcast, ipLocale);
                    }
                    catch (Exception ex)
                    {
                        info = ex.Message;
                    }
                }
            } while (scelta != 0);
        }

        
    }
}
